extends Timer

var speed = Vector2()	
var first_step = true
var max_h = 0.0
var final_h = 0.0
var start_h = 0.0
var h = 0


onready var rune = get_node("..")

# Called when the node enters the scene tree for the first time.
func _ready():
	first_step = true


# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	if time_left:
		var pos = rune.get_global_position()
		var speed_capped_x = speed.x
		var speed_capped_y = speed.y
		if pos.x < 0.0:
			speed_capped_x = max(0, speed_capped_x)
		if pos.x > global.screen_size_x:
			speed_capped_x = min(0, speed_capped_x)
		if pos.y < 0.0:
			speed_capped_y = max(0, speed_capped_y)
		if pos.y > global.screen_size_y:
			speed_capped_y = min(0, speed_capped_y)
		
		rune.set_global_position(pos + Vector2(speed_capped_x, speed_capped_y) * delta)
		
		if first_step and time_left <= wait_time / 2.0:
			first_step = false
		
		h = (time_left / wait_time) * start_h + (1 - time_left / wait_time) * final_h + sin(PI * (1 - time_left / wait_time)) * 10.0
		
		if first_step:
			rune.update_height(h, 120)
		else:
			rune.update_height(h, (120 + final_h) / 2.0)
			
func start_move(dx = 0.0, dt = 1.0):
	speed = dx / dt
	wait_time = dt
	first_step = true
	final_h = compute_final_h(dx) + 1.0
	start_h = rune.height
	max_h = max(start_h, final_h) + 10.0
	start()
	rune.z_index = 120

func compute_final_h(dx):
	return get_node("../..").get_top_height(get_node("..").get_global_position() + dx, rune.rune_size)
