extends Node2D

var height = 0
var ombrage = 0
var team = 0
var is_rune = true
var is_flying = false
var found = false

var rune_size = 3600.0  # 60.0 * 60.0

var base_modulate = Color()

onready var moveur = get_node("Move")
onready var level = get_node("..")

var particule_node

# Called when the node enters the scene tree for the first time.
func _ready():
	moveur.connect("timeout", self, "land")
	base_modulate = modulate
	z_index = 100.0

func _process(delta):
	if team != 0 and not found:
		pass
#		base_modulate = base_modulate.lightened(0.001)
#		modulate = base_modulate.darkened(ombrage)
	if found:
		moveur.start_move(found.get_global_position() - get_global_position())

func found(modulate_param, founder):
	found = founder
	ombrage = 0.0
	base_modulate = modulate_param
	modulate = base_modulate.darkened(ombrage)
	z_index = 100.0
	get_node("Sprite").scale = Vector2(0.35, 0.35)
	get_node("Area2D").unset_mouse_rune()
	return self
	# yield(get_tree().create_timer(2.0), "timeout")
	# queue_free()
	
func land():
	var v = moveur.speed.length() / 3200.0 + 0.05
	if v >= 0.2:
		var max_h = 0
		for rune in get_overlapping_runes(true):
			max_h = max(max_h, rune.height)
			var d = rune.get_global_position() - get_global_position()
			var i = 200.0 - d.length()
			rune.throw(rune.get_global_position() + (d.normalized() * i * v), i * v / 100.0)
		update_height(max_h)
	else:
		var max_h = -1
		for rune in get_overlapping_runes():
			rune.add_ombrage()
			max_h = max(max_h, rune.height)
		update_height(max_h + 1)
	if global.sound_number <= 10.0:
		global.sound_number += 1.0
		get_node("Land").stream = global.random_landing()
		get_node("Land").play()
	is_flying = false

func throw(target, dt= 1.0):
	update_ombrage(0.0)
	# update_height(height + 10)
	moveur.start_move(target - get_global_position(), dt)
	is_flying = true
	get_node("Area2D").unset_mouse_rune()

func set_team(t):
	var particule_blueprint = load("res://Object/Particules.tscn")
	var particules = particule_blueprint.instance()
	particule_node = particules
	particules.set_global_position(get_global_position())
	add_child(particules)
	team = t
	

func get_overlapping_runes(max_height = false):
	return level.get_overlapping_runes(get_global_position(), rune_size, self, max_height)

func add_ombrage():
	var no = 1 - (1-ombrage) * 0.98
	update_ombrage(no)

func update_ombrage(o):
	ombrage = o
	update_modulate()

func update_modulate():
	modulate = base_modulate.darkened(ombrage)
	
func update_height(h, z_override = null):
	height = h
	var s = 50.0 / max(45, 100 - h)
	if not found:
		get_node("Sprite").scale = Vector2(s, s)
	
	if z_override:
		z_index = floor(z_override)
		get_node("Node/RemoteTransform2D/RemoteTransform2D/Sprite").z_index = floor(z_override - 1)
	else:
		z_index = floor(h)
		get_node("Node/RemoteTransform2D/RemoteTransform2D/Sprite").z_index = floor(h - 1)

func hint():
	particule_node.hint()
