extends Node2D

#export var ts = 1.0
export var team = 1

onready var grab = get_node("Grab")

onready var main = get_node("Main")
onready var bras = get_node("Bras")
onready var abras = get_node("Avantbras")

# var front
var back
var grabbed_rune
var cd_boom = 0.0

export var anim_time = 0.0

var throwing = false

var tchoutchou = self

onready var moveur = get_node("Move")

# Called when the node enters the scene tree for the first time.
func _ready():
	global.connect("restart", self, "reset")
	selection.inited = true

func front():
	return get_global_position() + Vector2(130,0).rotated(get_rotation() - PI / 2.0)
	
# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	if cd_boom >= 0.0:
		cd_boom -= delta
	if not grab.is_playing():
		grabbed_rune = get_node("..").get_top_rune(front(), 100.0 * 100.0)
		if grabbed_rune:
			var anim = ""
			if grabbed_rune.team == team:
				tchoutchou = grabbed_rune.found(Color(1.0, 1.0, 1.0), tchoutchou)
				global.rune_found()
				anim = "teammed"
			else:
				back = get_global_position() + Vector2(250 + randf() * 50.0, randf() * 50.0).rotated(get_rotation() + PI / 2.0)
				anim = "throw"
			grab.play(anim)

func move_absolut(target):
	set_rotation((target - get_global_position()).angle() + PI / 2.0)
	var p_move = (max(0, (target - get_global_position()).length() - 130.0))* (target - get_global_position()).normalized()
	moveur.start_move(p_move)

func throw_grabbed():
	grabbed_rune.throw(back)

func place_main(step):
	var end
	var dt
	match step:
		0:  # on the rock
			end = grabbed_rune.get_global_position()
			dt = 0.5
		1:  # shot
			end = get_global_position()
			dt = 0.26
		2:  # refill
			end = front()
			dt = 0.24
	whole_bras(end, dt)

func reset():
	grab.stop()
	grabbed_rune = null
	whole_bras(front(), 0.26)

func whole_bras(end, dt):
	main.start(end, dt)
	bras.start(end, dt)
	abras.start(end, dt)

func boom(center):
	cd_boom += 2.0
	get_node("Particles2D").set_global_position(center)
	get_node("Particles2D").restart()
	get_node("AudioStreamPlayer").play()
	var runes_to_move = get_node("..").get_overlapping_runes(center, 40000.0)
	var max_h = 0
	for rune in runes_to_move:
		max_h = max(rune.height, max_h)
	var gpos
	var dp
	var f
	for rune in runes_to_move:
		gpos = rune.get_global_position() 
		dp = (gpos - center)
		f = (10.0 + rune.height) * 45.0 / max(1.0, 10.0 + 0.9 * max_h - rune.height)
		var factord = (250.0 - dp.length()) / 200.0
		var c = factord * factord * factord * f
		if c >= 24.0:
			rune.throw(rune.get_global_position() + (3 + randf()) * c * dp.normalized(), factord / 2.0)
	
func _input(event):
	if event.is_action_pressed("boom"):
		if cd_boom <=0 and tchoutchou != self:
			var old_tchoutchou = tchoutchou.found
			get_node("..").runes_team.erase(tchoutchou)
			tchoutchou.queue_free()
			tchoutchou = old_tchoutchou
			boom(get_global_mouse_position())
