extends Node2D

export var nmbr_rune = 0
export var dt = 0.02

export var time_hint = 25.0

var timer_hint = 0.0

var delta_left

export var size_level_x = 800
export var size_level_y = 480

onready var rune_blueprint = load("res://Object/Rune.tscn")
onready var startup = get_node("Startup")

var rune_i = 0
var timer_stopped = false
var team_one = []
var runes_team = {}
# Called when the node enters the scene tree for the first time.
func _ready():
	
	
	delta_left = dt
	
	startup.connect("timeout", self, "end_startup")
#	for i in range(nmbr_rune):
#		spawn_rune()
	selection.level = self
	global.level = self
	global.connect("restart", self, "stop_timer")
	
	global.prestart()

func start(nbr_team, nbr_tot):
	team_one = []
	rune_i = 0
	nmbr_rune = nbr_tot
	dt = 0.02
	delta_left = 0
	timer_hint = 0.0
	timer_stopped = false
	runes_team = {}
	for i in range(nbr_team):
		team_one.append(randi() % 100)
	startup.start()

func stop_timer():
	timer_stopped = true

func end_startup():
	dt = 0.25
	

# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	delta_left -= delta
	timer_hint += delta
	if nmbr_rune > 0 and delta_left <= 0.0:
		delta_left += dt
		nmbr_rune -= 1
		spawn_rune()
	if timer_hint >= time_hint and not timer_stopped:
		timer_hint -= time_hint
		for rune in runes_team.keys():
			if rune:
				rune.hint()


func spawn_rune(pos = null):
	rune_i += 1
	if pos == null:
		pos = get_rv()
	var rune = rune_blueprint.instance()
	var start_pos = Vector2(pos.x, - size_level_y)
	if rune_i in team_one:
		rune.set_team(1)
		runes_team[rune] = rune
		start_pos = Vector2(- size_level_x / 2.0, - size_level_y / 2.0)
	rune.set_global_position(start_pos)
	rune.set_rotation(randf() * PI * 2)
	add_child(rune)
	rune.throw(pos)


func get_overlapping_runes(pos, radius, ignore = null, max_height = false):  # moyen de restrict a quel celle du dessus
	var overlapping_runes = []
	var max_h = 0
	for child in get_runes():
		if (child != ignore) and (child.get_global_position().distance_squared_to(pos) < (radius)):
			overlapping_runes.append(child)
			max_h = max(max_h, child.height)
	if max_height:
		var tmp_rune = overlapping_runes
		overlapping_runes = []
		for rune in tmp_rune:
			if rune.height >= max_h - 1:
				overlapping_runes.append(rune)
	
	return overlapping_runes

func get_top_rune(pos, radius):
	var h = 0
	var d = radius
	var best_rune = null
	if selection.mouse_target and selection.mouse_target.rune.get_global_position().distance_squared_to(pos) <= d:
		best_rune = selection.mouse_target.rune
	else:
		for rune in get_overlapping_runes(pos, radius):
			if rune.height >= h and rune.get_global_position().distance_squared_to(pos) <= d:
				best_rune = rune
				d = rune.get_global_position().distance_squared_to(pos)
				h = rune.height
	
	return best_rune  # Can be null

func get_runes():
	var runes = []
	for child in get_children():
		if "is_rune" in child and not child.found and not child.is_flying:
			runes.append(child)
	return runes
	
func get_rv():
	return Vector2(randf() * size_level_x + size_level_x / 3.0, randf() * size_level_y + size_level_y / 3.0)

func clean_all_runes():
	for child in get_children():
		if "is_rune" in child:
			child.queue_free()
	get_node("Runneur").tchoutchou = get_node("Runneur")

func get_top_height(pos, d):
	var top_rune = get_top_rune(pos, d)
	if top_rune:
		return top_rune.height
	else:
		return 0
