extends Node

var nmbr_team_tot = 1
var nmbr_rune_tot = 150
var time_left_tot = 65.0
var lvl = 0
var lvls = [
	{"nmbr_team_tot": 1, "nmbr_rune_tot": 150, "time_left_tot": 55.0},
	{"nmbr_team_tot": 4, "nmbr_rune_tot": 200, "time_left_tot": 65.0},
	{"nmbr_team_tot": 8, "nmbr_rune_tot": 290, "time_left_tot": 75.0},
	{"nmbr_team_tot": 10, "nmbr_rune_tot": 350, "time_left_tot": 110.0},
	{"nmbr_team_tot": 12, "nmbr_rune_tot": 450, "time_left_tot": 120.0},
]

var time_left = 65.0

var restarting = true

var number_rune = 3
var number_rune_found = 0

var sound_number = 0.0
var landing_sounds = []
var nbr_sounds = 4

var color = {1: Color(116, 180, 108)}

var level

var screen_size_x = 1280
var screen_size_y = 720

signal found
signal restart


# Called when the node enters the scene tree for the first time.
func _ready():
	for i in range(nbr_sounds):
		landing_sounds.append(load("res://Object/landing" + str(i + 1) + ".wav"))

func prestart():
	yield(get_tree().create_timer(0.7), "timeout")
	load_lvl(lvl)
	init(nmbr_team_tot, nmbr_rune_tot)

func load_lvl(i):
	if i >= lvls.size():
		selection.inited = false
		get_tree().change_scene("res://UI/Fin.tscn")
		return false
	else:
		nmbr_team_tot = lvls[i]["nmbr_team_tot"]
		nmbr_rune_tot = lvls[i]["nmbr_rune_tot"]
		time_left_tot = lvls[i]["time_left_tot"]
		return true
	
func _process(delta):
	if number_rune > number_rune_found:
		time_left -= delta
		if time_left <= 0.0:
			emit_signal("found")
	sound_number = max(0, sound_number - delta * 10.0)

func init(nbr_rune, nbr_total):
	level.get_node("Intro").play()
	number_rune = nbr_rune
	number_rune_found = 0
	time_left = time_left_tot
	yield(get_tree().create_timer(4.7), "timeout")
	restarting = false
	level.start(nbr_rune, nbr_total)
	emit_signal("found")
	
func rune_found():
	number_rune_found = number_rune_found + 1
	emit_signal("found")

func restart(won):
	if not restarting:
		emit_signal("restart")
		restarting = true
		level.clean_all_runes()
		if won:
			lvl += 1
		if load_lvl(lvl):
			init(nmbr_team_tot, nmbr_rune_tot)

func random_landing():
	return landing_sounds[randi() % nbr_sounds]
